package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.NumberLiteral;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.impl.CharConstant;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.parser.ScannerHelper;

public class CharLiteral extends NumberLiteral {
  char value;
  
  public CharLiteral(char[] token, int s, int e) {
    super(token, s, e);
    computeValue();
  }
  
  public void computeConstant() {
    this.constant = CharConstant.fromValue(this.value);
  }
  
  private void computeValue() {
    if ((this.value = this.source[1]) != '\\')
      return; 
    char digit;
    switch (digit = this.source[2]) {
      case 'b':
        this.value = '\b';
        return;
      case 't':
        this.value = '\t';
        return;
      case 'n':
        this.value = '\n';
        return;
      case 'f':
        this.value = '\f';
        return;
      case 'r':
        this.value = '\r';
        return;
      case '"':
        this.value = '"';
        return;
      case '\'':
        this.value = '\'';
        return;
      case '\\':
        this.value = '\\';
        return;
    } 
    int number = ScannerHelper.getNumericValue(digit);
    if ((digit = this.source[3]) != '\'') {
      number = number * 8 + ScannerHelper.getNumericValue(digit);
    } else {
      this.constant = CharConstant.fromValue(this.value = (char)number);
      return;
    } 
    if ((digit = this.source[4]) != '\'')
      number = number * 8 + ScannerHelper.getNumericValue(digit); 
    this.value = (char)number;
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream, boolean valueRequired) {
    int pc = codeStream.position;
    if (valueRequired)
      codeStream.generateConstant(this.constant, this.implicitConversion); 
    codeStream.recordPositionsFrom(pc, this.sourceStart);
  }
  
  public TypeBinding literalType(BlockScope scope) {
    return (TypeBinding)TypeBinding.CHAR;
  }
  
  public void traverse(ASTVisitor visitor, BlockScope blockScope) {
    visitor.visit(this, blockScope);
    visitor.endVisit(this, blockScope);
  }
}
